Shell 脚本“||” {}”可读的替代方案

发布于 2024-12-25 12:49:28 字数 277 浏览 1 评论 0原文

当我遇到包含此代码的 这个答案 时,我正在寻找一种方法来检查是否使用 Shell 脚本安装了程序:

hash foo 2>&- || { echo >&2 "I require foo but it's not installed.  Aborting."; exit 1; }

但是该代码不太(人类)可读,该语法的替代方案是什么?

I was looking for a way to check if a program is installed using Shell Script when I came across this answer which contained this code:

hash foo 2>&- || { echo >&2 "I require foo but it's not installed.  Aborting."; exit 1; }

But that code isn't very (human) readable, what is the alternative for that syntax?

如果你对这篇内容有疑问,欢迎到本站社区发帖提问 参与讨论,获取更多帮助,或者扫码二维码加入 Web 技术交流群。

扫码二维码加入Web技术交流群

发布评论

需要 登录 才能够评论, 你可以免费 注册 一个本站的账号。

评论(2

心碎无痕… 2025-01-01 12:49:28

可读性是非常主观的。我特别认为,一旦您知道 || 表示短路 OR ,原文就非常具有可读性。因此,您将原文读作“执行此操作,OR 如果该操作失败,则执行此操作”。

不使用 || 的等效代码是:

if ! hash foo 2>&-
then
    echo >&2 "I require foo but it's not installed.  Aborting."
    exit 1
fi

Readability is very subjective. I particularly think the original is very readable, once you know that || means a short-circuiting OR. So you read the original as "do this, OR this if that one fails".

The equivalent code without using || is:

if ! hash foo 2>&-
then
    echo >&2 "I require foo but it's not installed.  Aborting."
    exit 1
fi
挖鼻大婶 2025-01-01 12:49:28

对于任何习惯 shell 脚本的人来说这是完全可读的,因为它是一个习惯用法。可读性的唯一障碍是缺乏换行符:

hash foo 2>&- || {
  echo >&2 "I require foo but it's not installed.  Aborting."
  exit 1
}

that's perfectly readable for anyone accustomed to shell scripts, because it's an idiom. the only hindrance to readability is the lack of newlines:

hash foo 2>&- || {
  echo >&2 "I require foo but it's not installed.  Aborting."
  exit 1
}
~没有更多了~
我们使用 Cookies 和其他技术来定制您的体验包括您的登录状态等。通过阅读我们的 隐私政策 了解更多相关信息。 单击 接受 或继续使用网站,即表示您同意使用 Cookies 和您的相关数据。
原文